--- check_snmp_storage.pl.orig	2010-06-10 18:13:18.682206376 +0200
+++ check_snmp_storage.pl	2010-06-16 15:49:44.394552750 +0200
@@ -489,18 +489,28 @@
 verb("storages selected : $num_int");
 if ( $num_int == 0 ) { print "Unknown storage : $o_descr : ERROR\n" ; exit $ERRORS{"UNKNOWN"};}
 
-my $result=undef;
+my $result = undef;
 
-if (Net::SNMP->VERSION < 4) {
-  $result = $session->get_request(@oids);
-} else {
-  if ($session->version == 0) { 
-    # snmpv1
-    $result = $session->get_request(Varbindlist => \@oids);
+for ( my $offset = 0; $offset < $count_oid; $offset += 12 ) {
+  my $partial_result = undef;
+  my $offset_high = $offset + 11 < $count_oid ? $offset + 11 : $count_oid - 1;
+  my @partial_oids = @oids[$offset..$offset_high];
+  if (Net::SNMP->VERSION < 4) {
+    $partial_result = $session->get_request(@partial_oids);
   } else {
-    # snmp v2c or v3 : get_bulk_request is not really good for this, so do simple get
-    $result = $session->get_request(Varbindlist => \@oids);
-    foreach my $key ( keys %$result) { verb("$key  : $$result{$key}"); }
+    if ($session->version == 0) {
+      # snmpv1
+      $partial_result = $session->get_request(Varbindlist => \@partial_oids);
+    } else {
+      # snmp v2c or v3 : get_bulk_request is not really good for this, so do simple get
+      $partial_result = $session->get_request(Varbindlist => \@partial_oids);
+      foreach my $key ( keys %$partial_result) { verb("$key  : $$partial_result{$key}"); }
+    }
+  }
+
+  if ( defined($partial_result) ) {
+    %$result = () if !defined($result);
+    %$result = ( %$result, %$partial_result );
   }
 }
 
